import QtQuick 2.12
import QtQuick.Controls 2.12
import QtQuick.Layouts 1.12

ApplicationWindow {
    visible: true

    width: 400
    height: 500

    property var strings: [
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "cccccccccccccccccccccccccccccccc",
        "dddddddddddddddddddddddddddddddd",
        "eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee",
        "ffffffffffffffffffffffffffffffff",
        "gggggggggggggggggggggggggggggggg",
        "hhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhh",
        "jjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjj",
        "kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk",
        "llllllllllllllllllllllllllllllll",
        "mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm",
        "nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn",
        "oooooooooooooooooooooooooooooooo",
        "pppppppppppppppppppppppppppppppp",
        "qqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqq",
        "rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr",
        "ssssssssssssssssssssssssssssssss",
        "tttttttttttttttttttttttttttttttt",
        "uuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuu",
        "vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv",
        "wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww",
        "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx",
        "yyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy",
        "zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz"
    ]

    ScrollView {
        anchors.fill: parent

        Row {
            spacing: 10

            height: childrenRect.height
            width: childrenRect.width

            Repeater {
                model: Qt.fontFamilies()

                Column {
                    id: column

                    property var font: modelData

                    height: childrenRect.height
                    width: childrenRect.width

                    spacing: 5

                    Text {
                        text: font.family

                        font.family: column.font
                    }

                    Repeater {
                        model: strings

                        Item {
                            id: nameItem

                            visible: true

                            width: idealTextMetrics.width
                            height: nameText.contentHeight

                            Rectangle {anchors.fill: parent; color: "orange" }

                            Text {
                                id: nameText

                                anchors.centerIn: parent
                                width: parent.width

                                text: idealTextMetrics.text
                                color: "black"

                                font.family: column.font

                                TextMetrics {
                                    id: idealTextMetrics

                                    font: nameText.font

                                    text: modelData
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
